# Procedure to run HIz2 for z=0.1,0.9,0.1 and embed in
# final image
#                        For VLA upgrade simulation. JEH 1/31/99
#
procedure upgrade(mom0,mom2,zout)
string mom0="mom0"      {prompt="MOM0 input (mJy/b km/s)"}
string mom2="mom2"      {prompt="MOM2 input (m/s rms)"}
string zout="zout"      {prompt="output z-mosaic"}
int outsize=200         {prompt="output image size (pixels)"}
real z1=0.005		{prompt="Redshift of input image"}
real dx1=5.0		{prompt="pixel size of input image (arcsec)"}
real FWHM1=18.0	        {prompt="FWHM resolution of input image (arcsec)"}
real dx2=0.5		{prompt="pixel size of output image (arcsec)"}
real FWHM2=1.6	        {prompt="FWHM resolution of output image at z=0 (arcsec)"}
real Ho=75		{prompt="Hubbles Constant"}
real qo=0.1		{prompt="deceleration parameter"}
real Tsys=28		{prompt="Tsys (K)"}
real eta=0.55		{prompt="efficiency"}
int  Nant=27		{prompt="Number of Array Elements"}
int  Nif=2		{prompt="Number of IF pairs"}
real texp=2700.0        {prompt="exposure time in hours"}

begin
        real z
        int zz,i,j,x1,x2,y1,y2

# needs mknoise from noao.artdata package
     mknoise(zout,ncol=3*outsize,nline=3*outsize,background=0,poisson-,ncosray=0,rdnoise=0,comments-)

     i=0
     j=3
     for(z=0.1;z<0.9;z=z+0.1)
     {
         if (i>2) 
	 {
	    i=0
	    j=j-1
	 }
	 zz=int(10.0*z+0.1)
	# print(z,zz)
         HIz2(mom0,mom2,zout//"_"//zz,outsize=outsize,z1=z1,dx1=dx1,FWHM1=FWHM1,z2=z,dx2=dx2,FWHM2=FWHM2,Ho=Ho,qo=qo,Tsys=Tsys,eta=eta,Nant=Nant,Nif=Nif,texp=texp)
         x1=i*outsize+1
         x2=x1+outsize-1
         y2=j*outsize
         y1=y2-outsize+1
         imcopy(zout//"_"//zz,zout//"["//x1//":"//x2//","//y1//":"//y2//"]")
	 #printf("z=%5.2f zz=%4d i=%4d j=%4d x1=%4d x2=%4d y1=%4d y2=%4d\n",z,zz,i,j,x1,x2,y1,y2)
         i=i+1
     }

        mkheader(zout,zout//"_1",append-)
end
